package com.jeeplus.centerservice.enums;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * 流程枚举
 */
public enum TaskAliasEnum {

    REIMBURSEMENT ("13,102", "Process_1665383385070");

    /**
     *  ccpm
     */
    private String ccpmTaskAlias;

    /**
     *  cpa
     */
    private String cpaTaskAlias;

    TaskAliasEnum(String ccpmTaskAlias, String cpaTaskAlias) {
        this.ccpmTaskAlias = ccpmTaskAlias;
        this.cpaTaskAlias = cpaTaskAlias;
    }

    public String getCcpmTaskAlias() {
        return ccpmTaskAlias;
    }

    public String getCpaTaskAlias() {
        return cpaTaskAlias;
    }

    public static TaskAliasEnum getByCcpm(String value) {
        TaskAliasEnum result = null;
        for (TaskAliasEnum s : values()) {
            if (s.getCcpmTaskAlias() == value) {
                result = s;
                break;
            }
        }
        return result;
    }

    public static TaskAliasEnum getByCcpmContains(String value) {
        TaskAliasEnum result = null;
        for (TaskAliasEnum s : values()) {
            List<String> stringList = Arrays.asList(s.getCcpmTaskAlias().split(","));
            if (stringList.contains(value)) {
                result = s;
            }
        }
        return result;
    }

    public static TaskAliasEnum getByCpa(String value) {
        TaskAliasEnum result = null;
        for (TaskAliasEnum s : values()) {
            if (s.getCpaTaskAlias() == value) {
                result = s;
                break;
            }
        }
        return result;
    }

    public static List<String> getCcpmListByCpa(String value) {
        List<String> result = new ArrayList<>();
        TaskAliasEnum byCpa = getByCpa(value);
        if (Objects.nonNull(byCpa)) {
            String[] split = byCpa.getCcpmTaskAlias().split(",");
            result.addAll(Arrays.asList(split));
        }
        return result;
    }

    @Override
    public String toString() {
        return "ccpm:" + this.ccpmTaskAlias + ", cpa:" + this.cpaTaskAlias;
    }
}
